      subroutine classificationr(n,zr1,r,boundary,contr,threshold1,threshold2,degtyper,rown)

      implicit none
      DOUBLE PRECISION :: zr1(0:300,0:300),zr(0:300,0:300),&
                          det,det1,det2,w00,w10,w01,w11,w20,w02, &
                          w100,w110,w101,w111,w120,w102, &
                          w200,w210,w201,w211,w220,w202, &
                          temp,temp1,temp2,temp3,temp4,temp5,temp6,    &
                          temp11,temp12,temp13,temp14,temp15,temp16,   &
                          temp21,temp22,temp23,temp24,temp25,temp26,   &
                          ttemp1,ttemp2,a,b,c,a1,b1,c1,a2,b2,c2,       &
                          r,boundary,threshold1,threshold2,ker,        &
                          rown,gtheta,ntheta,gfit,nfit,         &
                          gb,gc,nb,nc,ag1fit,ag2fit,an1fit,an2fit,     &
                          wg100,wg200,wn100,wn200

      INTEGER ::          n,k,k1,i,j,i1,j1,n1,n2,contr(0:300,0:300), &
                          s1,s2,s3,s4,degtyper(0:300,0:300)

      k=int(r*dble(n))
      k1=int(boundary*dble(n))

      s1=0
      s2=0
      s3=0
      s4=0
!      open(1312,file="gradient.dat",status="unknown")
!      open(1313,file="normal.dat",status="unknown")

!!!!! padding the boundary regions of reference image

      do i=k,k+n
         do j=k,k+n
            zr(i,j)=zr1(i-k,j-k)
         end do
      end do

      do i=0,k
         do j=0,k
            zr(k-i,k-j)=zr(k+i,k+j)
         end do
      end do

      do i=k+1,k+n
         do j=0,k
            zr(i,k-j)=zr(i,k+j)
         end do
      end do

      do i=0,k
         do j=0,k
            zr(k+n+i,k-j)=zr(k+n-i,k+j)
         end do
      end do

      do i=0,k
         do j=k+1,k+n
            zr(k+n+i,j)=zr(k+n-i,j)
         end do
      end do

      do i=0,k
         do j=0,k
            zr(k+n+i,k+n+j)=zr(k+n-i,k+n-j)
         end do
      end do

      do i=k+1,k+n
         do j=0,k
            zr(i,k+n+j)=zr(i,k+n-j)
         end do
      end do

      do i=0,k
         do j=0,k
            zr(k-i,k+n+j)=zr(k+i,k+n-j)
         end do
      end do

      do i=0,k
         do j=k+1,k+n
            zr(k-i,j)=zr(k+i,j)
         end do
      end do

!!!!! Start fitting the surface of reference image

      do i=k,k+n
         do j=k,k+n

!!!!! In a neighborhood of a given point, we first fit the surface and its gradient  !!!!!
!!!!! by the conventional local linear kernel smoothing procedure p.162              !!!!!

      w00=0D0
      w10=0D0
      w01=0D0
      w11=0D0
      w20=0D0
      w02=0D0

      do i1=i-k,i+k
         do j1=j-k,j+k

            ttemp1=dble(i1-i)/dble(n)
            ttemp2=dble(j1-j)/dble(n)
            temp=ker(ttemp1/r,ttemp2/r)

            w00=w00+temp
            w10=w10+temp*ttemp1
            w01=w01+temp*ttemp2
            w11=w11+temp*ttemp1*ttemp2
            w20=w20+temp*ttemp1**2D0
            w02=w02+temp*ttemp2**2D0

         end do
      end do

      det=w00*w20*w02+w10*w11*w01+w01*w10*w11- &
          w01*w20*w01-w10*w10*w02-w00*w11*w11

      temp1=w20*w02-w11**2D0
      temp2=w01*w11-w10*w02
      temp3=w10*w11-w01*w20
      temp4=w00*w02-w01**2D0
      temp5=w01*w10-w00*w11
      temp6=w00*w20-w10**2D0

      a=0D0
      b=0D0
      c=0D0

      do i1=i-k,i+k
         do j1=j-k,j+k


            ttemp1=dble(i1-i)/dble(n)
            ttemp2=dble(j1-j)/dble(n)
            temp=ker(ttemp1/r,ttemp2/r)

            a=a+zr(i1,j1)*temp*(temp1+temp2*ttemp1+temp3*ttemp2)
            b=b+zr(i1,j1)*temp*(temp2+temp4*ttemp1+temp5*ttemp2)
            c=c+zr(i1,j1)*temp*(temp3+temp5*ttemp1+temp6*ttemp2)

         end do
      end do

      if (abs(det) > 0D0) then
         a=a/det
         b=b/det
         c=c/det
      else
         a=0D0
         b=0D0
         c=0D0
      end if


!!!!! the gradient direction G(x,y)=(b(i,j),c(i,j)).            !!!!!
!!!!! the normal direction y=-b(i,j)/c(i,j)*x.                  !!!!!

      gb=0D0       !!!! gradient b (unit length)
      gc=0D0       !!!! gradient c (unit length)
      nb=0D0       !!!! normal b (unit length)
      nc=0D0       !!!! normal c (unit length)

      if(b == 0D0 .and. c == 0D0) then              !!!! it's just a flat plane

        if ((i-k)<k1 .or. (j-k)<k1 .or. (n-i+k)<k1 .or. (n-j+k)<k1) then
           contr(i-k,j-k)=3  !! type 3: boundary point
           s3=s3+1
        else 
           contr(i-k,j-k)=2  !! type 2: degenerate point; subtype 2: 2-D degenerate
           s2=s2+1
           degtyper(i-k,j-k)=2
        end if

      else          !!!! gradient exists

        !!!! decide gradient (gb,gc) and normal (nb,nc) in unit length: gb*nb+gc*nc=0
        if(b == 0D0) then
          gb=0D0
          gc=c/sqrt(c**2D0)
          nb=1D0
          nc=0D0
        else if(c == 0D0) then
          gb=b/sqrt(b**2D0)
          gc=0D0
          nb=0D0
          nc=1D0
        else
          gb=b/sqrt(b**2D0+c**2D0)
          gc=c/sqrt(b**2D0+c**2D0)
          nb=c/sqrt(b**2D0+c**2D0)
          nc=-b/sqrt(b**2D0+c**2D0)
        end if

        gtheta = atan(gc/gb)	!!!! the rotate angle along gradient direction
        ntheta = atan(nc/nb)	!!!! the rotate angle along normal direction

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!    fit two local constant kernel along gradient direction    !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        ag1fit=0D0
        ag2fit=0D0
        wg100=0D0
        wg200=0D0
        do i1=i-k,i+k
           do j1=j-k,j+k
               ttemp1=dble(i1-i)/dble(n)
               ttemp2=dble(j1-j)/dble(n)
               if(ttemp2 < gc/gb*ttemp1+r*rown/cos(atan(gc/gb)) .and. ttemp2 > gc/gb*ttemp1-r*rown/cos(atan(gc/gb))) then
                   if(ttemp2 < nc/nb*ttemp1) then
                       temp=ker(ttemp1/r,ttemp2/r)
                       ag1fit=ag1fit+zr(i1,j1)*temp
                       wg100=wg100+temp
                   else
                       temp=ker(ttemp1/r,ttemp2/r)
                       ag2fit=ag2fit+zr(i1,j1)*temp
                       wg200=wg200+temp
                   end if
               end if
           end do
        end do
        if (abs(wg100) > 0D0) then
           ag1fit=ag1fit/wg100
        else
           ag1fit=0D0
        end if
        if (abs(wg200) > 0D0) then
           ag2fit=ag2fit/wg200
        else
           ag2fit=0D0
        end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!    fit two local constant kernel along normal direction      !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        an1fit=0D0
        an2fit=0D0
        wn100=0D0
        wn200=0D0
        do i1=i-k,i+k
           do j1=j-k,j+k
               ttemp1=dble(i1-i)/dble(n)
               ttemp2=dble(j1-j)/dble(n)
               if(ttemp2 < nc/nb*ttemp1+r*rown/cos(atan(nc/nb)) .and. ttemp2 > nc/nb*ttemp1-r*rown/cos(atan(nc/nb))) then
                   if(ttemp2 < gc/gb*ttemp1) then
                       temp=ker(ttemp1/r,ttemp2/r)
                       an1fit=an1fit+zr(i1,j1)*temp
                       wn100=wn100+temp
                   else
                       temp=ker(ttemp1/r,ttemp2/r)
                       an2fit=an2fit+zr(i1,j1)*temp
                       wn200=wn200+temp
                   end if
               end if
           end do
        end do
        if (abs(wn100) > 0D0) then
           an1fit=an1fit/wn100
        else
           an1fit=0D0
        end if
        if (abs(wn200) > 0D0) then
           an2fit=an2fit/wn200
        else
           an2fit=0D0
        end if

!            write(1312,'(6f15.6)') gfit
!            write(1313,'(6f15.6)') nfit
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                      classify points                        !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        if ((i-k)<k1 .or. (j-k)<k1 .or. (n-i+k)<k1 .or. (n-j+k)<k1) then
           contr(i-k,j-k)=3  !! type 3: boundary point
           s3=s3+1
        else 
           if(abs(ag1fit-ag2fit) < threshold1) then
               contr(i-k,j-k)=2  !! type 2: degenerate point; subtype 2: 2-D degenerate
               s2=s2+1
               degtyper(i-k,j-k)=2
           else if(abs(an1fit-an2fit) < threshold2) then
               contr(i-k,j-k)=2  !! type 2: degenerate point; subtype 1: 1-D degenerate
               s4=s4+1
               degtyper(i-k,j-k)=1
           else
               contr(i-k,j-k)=1  !! type 1: non-degenerate point
               s1=s1+1
           end if
         end if

      end if

         end do
      end do

      write(*,*) "boundary point:"
      write(*,*) s3  !! boundary point
      write(*,*) "1-D degenerate:"
      write(*,*) s4  !! degenerate point, subtype1: 1-D
      write(*,*) "2-D degenerate:"
      write(*,*) s2  !! degenerate point, subtype2: 2-D
      write(*,*) "non-degenerate:"
      write(*,*) s1  !! non-degenerate point


      end subroutine classificationr


