      subroutine degenerate(n,zr1,zm1,r3,b,c,contm,contr,degtyper,degtypem)

      implicit none
      DOUBLE PRECISION :: r3,ker,b(0:300,0:300),c(0:300,0:300),&
                          zr(0:600,0:600),zm(0:600,0:600),&
                          dist,temp,temp1,temp2,&
                          b1(0:300,0:300),c1(0:300,0:300),&
                          b2(0:300,0:300),c2(0:300,0:300),&
                          rss1,rss2,zr1(0:300,0:300),zm1(0:300,0:300),&
                          rss3,temrss,temb(0:300,0:300),temc(0:300,0:300)
      INTEGER ::          n,k,i,j,i1,j1,i2,j2,contm(0:300,0:300),n1,n2,contr(0:300,0:300),&
                          degtyper(0:300,0:300),degtypem(0:300,0:300),&
                          total_n,i4,j4,k3

      k=int(r3*dble(n))
      k3=int(0.3D0*dble(n))    !!!!! padding width

      total_n=0
      do i4=-k,k
        do j4=-k,k
            total_n=total_n+1
        end do
      end do


!!!!! padding the boundary regions of reference image with radius 0.3

      do i=k3,k3+n
         do j=k3,k3+n
            zr(i,j)=zr1(i-k3,j-k3)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3-i,k3-j)=zr(k3+i,k3+j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zr(i,k3-j)=zr(i,k3+j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3+n+i,k3-j)=zr(k3+n-i,k3+j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zr(k3+n+i,j)=zr(k3+n-i,j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3+n+i,k3+n+j)=zr(k3+n-i,k3+n-j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zr(i,k3+n+j)=zr(i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3-i,k3+n+j)=zr(k3+i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zr(k3-i,j)=zr(k3+i,j)
         end do
      end do


!!!!! padding the boundary regions of match image with radius 0.3

      do i=k3,k3+n
         do j=k3,k3+n
            zm(i,j)=zm1(i-k3,j-k3)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3-i,k3-j)=zm(k3+i,k3+j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zm(i,k3-j)=zm(i,k3+j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3+n+i,k3-j)=zm(k3+n-i,k3+j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zm(k3+n+i,j)=zm(k3+n-i,j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3+n+i,k3+n+j)=zm(k3+n-i,k3+n-j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zm(i,k3+n+j)=zm(i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3-i,k3+n+j)=zm(k3+i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zm(k3-i,j)=zm(k3+i,j)
         end do
      end do


!!!!! Registrate the 2D-degenerate point (contr == 2) AND (degtyper == 2)
!!!!! Find a closet contr == 1 or degtyper == 1, apply its transformation to degenerate point
!!!!! Also compare to no move option

      do i=0,n
        do j=0,n
         if(contr(i,j)==2 .and. degtyper(i,j)==2) then

          !!!! initialize value
          do i1=0,n
            do j1=0,n
             if(contr(i1,j1)==1 .or. degtyper(i1,j1)==1) then
              dist=sqrt((dble(i)-dble(i1))**2D0+(dble(j)-dble(j1))**2D0)
              b1(i,j)=b(i1,j1)
              c1(i,j)=c(i1,j1)
             end if
            end do
          end do

         temp=0D0

          do i1=0,n
            do j1=0,n

             if(contr(i1,j1)==1 .or. degtyper(i1,j1)==1) then
               temp=sqrt((dble(i1)-dble(i))**2D0+(dble(j1)-dble(j))**2D0)
               if(temp<dist) then
                dist=temp
                b1(i,j)=b(i1,j1)
                c1(i,j)=c(i1,j1)
               end if
             end if

            end do
          end do

         temp1=dist

!!!!! Determine the residual square of estimated transformation vector
         rss1=0D0
         n1=0
         i1=int((dble(i)/dble(n)+b1(i,j))*dble(n))+k3
         j1=int((dble(j)/dble(n)+c1(i,j))*dble(n))+k3
         if(i1<0) then 
           i1=0
         end if
         if(i1>n+2*k3) then
           i1=n+2*k3
         end if
         if(j1<0) then
           j1=0
         end if
         if(j1>n+2*k3) then
           j1=n+2*k3
         end if
         do i2=i1-k,i1+k
           do j2=j1-k,j1+k
             if(i2>=0 .and. i2<=n+2*k3 .and. j2>=0 .and. j2<=n+2*k3) then
               if((i+i2-i1+k3)>=0 .and. (i+i2-i1+k3)<=n+2*k3 .and. (j+j2-j1+k3)>=0 .and. (j+j2-j1+k3)<=n+2*k3) then
                 rss1=rss1+((zm(i2,j2)-zr(i+(i2-i1)+k3,j+(j2-j1)+k3))**2D0)
                 n1=n1+1
               end if
             end if
           end do
         end do
         if(n1/=0) then
           rss1=rss1/dble(n1)
         end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!          !!!! initialize value
!          do i1=0,n
!            do j1=0,n
!             if(contm(i1,j1)==2) then
!              dist=sqrt((dble(i)-dble(i1))**2D0+(dble(j)-dble(j1))**2D0)
!              b2(i,j)=b(i1,j1)
!              c2(i,j)=c(i1,j1)
!             end if
!            end do
!          end do
!
!         temp=0D0
!
!          do i1=0,n
!            do j1=0,n
!
!             if(contm(i1,j1)==2) then
!              temp=sqrt((dble(i1)-dble(i))**2D0+(dble(j1)-dble(j))**2D0)
!               if(temp<dist) then
!                dist=temp
!                b2(i,j)=b(i1,j1)
!                c2(i,j)=c(i1,j1)
!               end if
!             end if
!
!            end do
!          end do
!
!         temp2=dist
!
!!!!! Determine the residual square of estimated transformation vector
!         rss2=0D0
!         i1=int((dble(i)/dble(n)+b2(i,j))*dble(n))
!         j1=int((dble(j)/dble(n)+c2(i,j))*dble(n))
!         if(i1<0) then 
!           i1=0
!         end if
!         if(i1>n) then
!           i1=n
!         end if
!         if(j1<0) then
!           j1=0
!         end if
!         if(j1>n) then
!           j1=n
!         end if
!         do i2=i1-k,i1+k
!           do j2=j1-k,j1+k
!             if(i2>=0 .and. i2<=n .and. j2>=0 .and. j2<=n) then
!               if((i+i2-i1)>=0 .and. (i+i2-i1)<=n .and. (j+j2-j1)>=0 .and. (j+j2-j1)<=n) then
!                 rss2=rss2+(zm1(i2,j2)-zr1(i+(i2-i1),j+(j2-j1)))**2D0
!               end if
!             end if
!           end do
!         end do
!
!
!!!!! Determine the temporary transformation vector
!         if(rss1>rss2) then
!           temb(i,j)=b2(i,j)
!           temc(i,j)=c2(i,j)
!           temrss=rss2
!         else if(rss1<rss2) then
           temb(i,j)=b1(i,j)
           temc(i,j)=c1(i,j)
           temrss=rss1*sqrt(dble(n1)/dble(total_n))
!         else if(temp1<temp2) then
!           temb(i,j)=b1(i,j)
!           temc(i,j)=c1(i,j)
!           temrss=rss1
!         else
!           temb(i,j)=b2(i,j)
!           temc(i,j)=c2(i,j)
!           temrss=rss2
!         end if


!!!!! Compute the rss if the point does not move
         rss3=0D0
         n2=0
         i1=i+k3
         j1=j+k3
         do i2=i1-k,i1+k
           do j2=j1-k,j1+k
             if(i2>=0 .and. i2<=n+2*k3 .and. j2>=0 .and. j2<=n+2*k3) then
               if((i+i2-i1+k3)>=0 .and. (i+i2-i1+k3)<=n+2*k3 .and. (j+j2-j1+k3)>=0 .and. (j+j2-j1+k3)<=n+2*k3) then
                 rss3=rss3+((zm(i2,j2)-zr(i+(i2-i1)+k3,j+(j2-j1)+k3))**2D0)
                 n2=n2+1
               end if
             end if
           end do
         end do
         if(n2/=0) then
           rss3=rss3/dble(n2)
         end if
         rss3=rss3*sqrt(dble(n2)/dble(total_n))    !!!!! normalize variance

!!!!! Determine the final transformation vector by comparing the rss3 and temrss
         if(temrss>rss3) then
           b(i,j)=0D0
           c(i,j)=0D0
         else
           b(i,j)=temb(i,j)
           c(i,j)=temc(i,j)
         end if


         end if
        end do
        if(mod(i,40) == 0) then
          write(*,*) i*2
        end if
      end do



      end subroutine degenerate



