
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                    !
!   This program is about image registration algorithm               !
!                       (based on 011211)                            !
!            (fit two local kenerl constant estimators )             !
!                (along gradient and normal direction)               !
!       (and using the abs difference of those two estimators)       !
!                    (to determine point types)                      !
!                                                                    !
!                                                                    !
!     Creator: Chen Xing                                             !
!     Date:    January 13 2011                                       !
!                                                                    !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      PROGRAM Registration

      implicit none
      DOUBLE PRECISION :: zr1(0:300,0:300),zm1(0:300,0:300),&  !! observed intensity functions
                          Rx(0:300,0:300),Ry(0:300,0:300),&  !! partial derivative from reference image
                          Mx(0:300,0:300),My(0:300,0:300),&  !! partial derivative from moved image
                          FR(0:300,0:300),FM(0:300,0:300),&  !! estimated intensity functions
                          r,sigma,threshold1,threshold2,r0,r1,r2,r3,&
                          b(0:300,0:300),c(0:300,0:300),&
                          xr(90000),yr(90000),xm(90000),ym(90000),&
                          fitm(0:300,0:300),i1,j1,ker,kernel,boundary,d1,d2,ker1,rker1,&
                          rown,r_nondeg,&
                          rmse,episilon  !! the threshold to control to reach the following num
      INTEGER ::          n,k,i,j,contr(0:300,0:300),contm(0:300,0:300),&
                          degtyper(0:300,0:300),degtypem(0:300,0:300),&
                          num  !! the number to control the adaptive radius for non-degenerate point search
      REAL ::             etime,elapsed(2),total



      n=127 !! image dimension
      sigma=0.0D0 !! noise variance
      boundary=0.0D0 !! the width of the boundary part, boundary > r1, should be zero in this paper
      r=0.015D0 !! the radius of nbhd used in classification for both images

      r3=0.005D0  !!used to be the nb diam for comparing in degenerate point subroutine

      rown=0.2D0       !! the entire length vs the entire width with the kernel ker

      b=0D0 !! transformation corresponding to first coordinate
      c=0D0 !! transformation corresponding to second coordinate
      threshold1=100.0 !! threshold value for gradient direction variability
      threshold2=0.0 !! threshold value for normal direction variability (threshold2 < threshold1)

      contr=0  !! indicator, 4 level indicates 4 different types of points in the reference image
      contm=0  !! indicator, 4 level indicates 4 different types of points in the match image
      degtyper=0    !! indicator of 2 different degenerate type: value 1: 1-D; value 2: 2-D (for ref image)
      degtypem=0    !! indicator of 2 different degenerate type: value 1: 1-D; value 2: 2-D (for match image)
      fitm=0D0

      d1= 0.03D0 !! diameter in case 1 nondegenerate point
!      num=4
!      episilon=1D0
      r_nondeg=0.2D0 !! diameter of neighborhood in control of searching for non-deg points


      open(13,file="oreference.dat",status="unknown")

      open(14,file="omatch.dat",status="unknown")

      open(19,file="fitted.dat",status="unknown")

      open(23,file="b.dat",status="unknown")

      open(24,file="c.dat",status="unknown")

      open(30,file="r_xnondeg.dat",status="unknown")

      open(31,file="r_ynondeg.dat",status="unknown")

      open(33,file="xcontr1d.dat",status="unknown")

      open(34,file="ycontr1d.dat",status="unknown")

      open(930,file="m_xnondeg.dat",status="unknown")

      open(931,file="m_ynondeg.dat",status="unknown")

!      open(41,file="b1.dat",status="unknown")

!      open(42,file="c1.dat",status="unknown")

!      open(43,file="b2.dat",status="unknown")

!      open(44,file="c2.dat",status="unknown")

!      open(64,file="inputfitted.dat",status="unknown")

      open(199,file="fitted.txt",status="unknown")

      open(1354,file="reference2.txt",status="unknown")


!!!!! Get the data

    call input(n,zr1,zm1)
      do i=0,n
         do j=0,n
          write(13,'(6f15.6)') zr1(i,j)
          write(1354,'(6f15.6)') zr1(i,j)
          write(14,'(6f15.6)') zm1(i,j)
         end do
      end do

!!!! classify points in reference image

    call classificationr(n,zr1,r,boundary,contr,threshold1,threshold2,degtyper,rown)

!!!! classify points in moved image

    call classificationm(n,zm1,r,boundary,contm,threshold1,threshold2,degtypem,rown)

!!!! output the non-degenerate points in reference image

      do i=0,n
        do j=0,n
          if(contr(i,j)==1) then
            write(30,'(6f15.6)') dble(i)/dble(n)
            write(31,'(6f15.6)') dble(j)/dble(n)
          end if
          if(degtyper(i,j)==1) then
            write(33,'(6f15.6)') dble(i)/dble(n)
            write(34,'(6f15.6)') dble(j)/dble(n)
          end if
          if(contm(i,j)==1) then
            write(930,'(6f15.6)') dble(i)/dble(n)
            write(931,'(6f15.6)') dble(j)/dble(n)
          end if
        end do
      end do


!!!! register non-degenerate point

    call nondegeneratetype(n,num,d1,zr1,zm1,b,c,contm,contr,episilon,r_nondeg,degtyper,degtypem)


!!!! register degenerate point

    call degenerate(n,zr1,zm1,r3,b,c,contm,contr,degtyper,degtypem)


!!!! register boundary point

    call boundarypoint(n,boundary,b,c,contm,contr)


!!!! get the final fitting of the image intensity function

    call fit(n,b,c,zm1,contm,fitm)

    do i=0,n
      do j=0,n

        if(contm(i,j)==1) then
         write(23,'(6f15.6)') b(i,j)
         write(24,'(6f15.6)') c(i,j)
        end if

        write(19,'(6f15.6)') fitm(i,j)
        write(199,'(6f15.6)') fitm(i,j)

      end do
    end do

!!!!! Show residual mean squared difference

      rmse=0D0
      do j=0,n
         do i=0,n
            rmse=rmse+(fitm(i,j)-zr1(i,j))**2D0
         end do
      end do
            rmse=sqrt(rmse/((dble(n+1))**2D0))
      write(*,*) rmse

      total=etime(elapsed)
      write(*,*) "time:"
      write(*,*) total


end PROGRAM Registration



!!!!! Define the conventional bivariate normal density function !!!!!
!!!!! as the kernel function.                                   !!!!!

      DOUBLE PRECISION function ker(x,y)
      DOUBLE PRECISION :: x,y,pi

      pi=3.14159D0

      ker=0D0

      if (x**2D0+y**2D0 <= 1D0) then
         ker=(exp(-(x**2D0+y**2D0)/2D0)-exp(-0.5D0))/ &
             (2D0*pi-3D0*pi*exp(-0.5D0))
      end if

      end function ker



!!!!! Define untruncated kernel function with square support !!!!!

      DOUBLE PRECISION function kernel(x,y)
      DOUBLE PRECISION :: x,y

      pi=3.14159D0

      kernel=0D0

      if (x <= 1D0 .and. x >= -1D0 .and. y <= 1D0 .and. y >= -1D0) then
        kernel=(1D0/(2D0*pi)*exp(-(x**2D0+y**2D0)/2D0))/((0.8413447D0-0.1586553D0)**2D0)
      end if

      end function kernel



!!!!! Define truncated kernel function !!!!!

      DOUBLE PRECISION function ker1(x,y,hn,pn)
      DOUBLE PRECISION :: x,y,hn,pn,kernel

      ker1=kernel(x/hn,y/pn)

      end function ker1



!!!!! Define the rotational kernel functions !!!!!

      DOUBLE PRECISION function rker1(theta,x,y,hn,pn)
      DOUBLE PRECISION :: theta,x,y,hn,pn,ker1

      if(y == 0D0) then
        rker1 = ker1(sign(1D0,x)*sqrt(x**2D0+y**2D0)*cos(-theta), sign(1D0,x)*sqrt(x**2D0+y**2D0)*sin(-theta),hn,pn)
      else if(y > 0D0 .and. x == 0D0) then
        rker1 = ker1(sign(1D0,x)*sqrt(x**2D0+y**2D0)*cos(3.14159D0/2D0-theta), &
                     sign(1D0,x)*sqrt(x**2D0+y**2D0)*sin(3.14159D0/2D0-theta),hn,pn)
      else if(y < 0D0 .and. x == 0D0) then
        rker1 = ker1(sign(1D0,x)*sqrt(x**2D0+y**2D0)*cos(-3.14159D0/2D0-theta), &
                     sign(1D0,x)*sqrt(x**2D0+y**2D0)*sin(-3.14159D0/2D0-theta),hn,pn)
      else
        rker1 = ker1(sign(1D0,x)*sqrt(x**2D0+y**2D0)*cos(atan(y/x)-theta), &
                     sign(1D0,x)*sqrt(x**2D0+y**2D0)*sin(atan(y/x)-theta),hn,pn)
      endif

      end function rker1




